#ifndef _XENFB_H_
#define _XENFB_H_

#include <stdbool.h>
#include <stdint.h>

struct xenfb
{
	uint8_t *pixels;

	int row_stride;
	int depth;
	int width;
	int height;

	void *user_data;

	void (*update)(struct xenfb *xenfb, int x, int y, int width, int height);
};

struct xenfb *xenfb_new(void);
void xenfb_delete(struct xenfb *xenfb);

bool xenfb_attach_dom(struct xenfb *xenfb, int domid);

int xenfb_get_fileno(struct xenfb *xenfb);
int xenfb_on_incoming(struct xenfb *xenfb);

int xenfb_send_key(struct xenfb *xenfb, bool down, int keycode);
int xenfb_send_motion(struct xenfb *xenfb, int rel_x, int rel_y);
int xenfb_send_button(struct xenfb *xenfb, bool down, int button);

#endif
